//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@math.unice.fr
//
//		Copyright 1998,1999, All Rights Reserved.
//
//--------------------------------------------------------------------------

#include <stdio.h>

#include <InterfaceKit.h>
#include "tab_view.h"

KTab::KTab(BView * tabView):BTab(tabView){fFirstTime=true;};
KTab::KTab(BMessage *archive):BTab(archive){fFirstTime=true;}; 
    
void KTab::Select(BView *owner)
{
	if (!fFirstTime) {
		BTab::Select(owner);
	}
   	if (View()!=NULL&&owner->Window()!=NULL) {
    	BTabView *tv=(BTabView *)owner;
    	BRect rect=tv->Bounds();
    	rect.bottom-=tv->TabHeight();
    	rect.InsetBy(5,5);
    	View()->MoveTo(rect.left,rect.top);
    	View()->ResizeTo(rect.Width(),rect.Height());
    	//rect.PrintToStream();
    }
	if (fFirstTime) {
		BTab::Select(owner);
	}
    fFirstTime=false;
}

KTabView::KTabView(BRect frame, const char *name, 
         button_width width, 
         uint32 resizingMode, 
         uint32 flags):
     	BTabView(frame,name,width,resizingMode,flags)
{
}

void KTabView::AddTab(BView *target, BTab *tab)
{
	if (tab==NULL)
		BTabView::AddTab(target,new KTab());
	else
		BTabView::AddTab(target,tab);
}